javax.faces.flow

## Class Flow

- java.lang.Object
- - javax.faces.flow.Flow

-     public abstract class Flow
      extends Object

  Flow is the runtime representation of a Faces Flow. Once placed into service by the runtime, an instance of this class is immutable. The implementation must be thread-safe because instances will be shared across all usages of the flow within the application.

  Since:
    2.2

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Flow()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract String` | `getClientWindowFlowId(ClientWindow curWindow)` Obtain the current `ClientWindow` from the `ExternalContext`.
    `abstract String` | `getDefiningDocumentId()` Return the immutable application unique identifier for the document in which the argument flow is defined.
    `abstract MethodExpression` | `getFinalizer()` Return the `MethodExpression` that must be called by the runtime as the last thing that happens before exiting this flow.
    `abstract FlowCallNode` | `getFlowCall(Flow targetFlow)` Return the `FlowCallNode` that represents calling the `targetFlow` from this flow, or `null` if `targetFlow` cannot be reached from this flow.
    `abstract Map<String,FlowCallNode>` | `getFlowCalls()` Return an immutable data structure containing all the flow call nodes declared for this flow.
    `abstract String` | `getId()` Return the immutable id for this Flow.
    `abstract Map<String,Parameter>` | `getInboundParameters()` Return an immutable data structure containing the inbound parameters that have been declared for this flow.
    `abstract MethodExpression` | `getInitializer()` Return the `MethodExpression` that must be called by the runtime immediately after activating any `FlowScoped` beans declared for this flow.
    `abstract List<MethodCallNode>` | `getMethodCalls()` Return an immutable data structure containing all the method call nodes declared for this flow.
    `abstract Map<String,Set<NavigationCase>>` | `getNavigationCases()`
    `abstract FlowNode` | `getNode(String nodeId)`
    `abstract Map<String,ReturnNode>` | `getReturns()` Return an immutable data structure containing all of the return nodes declared for this flow.
    `abstract String` | `getStartNodeId()` Return the immutable id for the default node that should be activated when this flow is entered.
    `abstract Map<String,SwitchNode>` | `getSwitches()` Return an immutable data structure containing all of the switch nodes declared for this flow.
    `abstract List<ViewNode>` | `getViews()` Return an immutable data structure containing all of the view nodes declared for this flow.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Flow

          public Flow()

  - ### Method Detail

    - #### getId

          public abstract String getId()

      Return the immutable id for this Flow. This must be unique within the defining document (such as an Application Configuration Resources file), but need not be unique within the entire application.

      Since:
        2.2

    - #### getDefiningDocumentId

          public abstract String getDefiningDocumentId()

      Return the immutable application unique identifier for the document in which the argument flow is defined.

      Since:
        2.2

    - #### getStartNodeId

          public abstract String getStartNodeId()

      Return the immutable id for the default node that should be activated when this flow is entered.

      Since:
        2.2

    - #### getFinalizer

          public abstract MethodExpression getFinalizer()

      Return the `MethodExpression` that must be called by the runtime as the last thing that happens before exiting this flow. Any `FlowScoped` beans declared for this flow must remain in scope until after control returns from the method referenced by this `MethodExpression`.

      Since:
        2.2

    - #### getInitializer

          public abstract MethodExpression getInitializer()

      Return the `MethodExpression` that must be called by the runtime immediately after activating any `FlowScoped` beans declared for this flow.

      Since:
        2.2

    - #### getInboundParameters

          public abstract Map<String,Parameter> getInboundParameters()

      Return an immutable data structure containing the inbound parameters that have been declared for this flow. See `FlowHandler.transition(javax.faces.context.FacesContext, javax.faces.flow.Flow, javax.faces.flow.Flow, javax.faces.flow.FlowCallNode, java.lang.String)` for the specification of how these parameters are used. Inbound parameters are associated with a specific flow instance, while outbound parameters are associated with a `FlowCallNode` that causes the transition to a new flow.

      Since:
        2.2

    - #### getViews

          public abstract List<ViewNode> getViews()

      Return an immutable data structure containing all of the view nodes declared for this flow.

      Since:
        2.2

    - #### getReturns

          public abstract Map<String,ReturnNode> getReturns()

      Return an immutable data structure containing all of the return nodes declared for this flow.

      Since:
        2.2

    - #### getSwitches

          public abstract Map<String,SwitchNode> getSwitches()

      Return an immutable data structure containing all of the switch nodes declared for this flow.

      Since:
        2.2

    - #### getFlowCalls

          public abstract Map<String,FlowCallNode> getFlowCalls()

      Return an immutable data structure containing all the flow call nodes declared for this flow.

      Since:
        2.2

    - #### getFlowCall

          public abstract FlowCallNode getFlowCall(Flow targetFlow)

      Return the `FlowCallNode` that represents calling the `targetFlow` from this flow, or `null` if `targetFlow` cannot be reached from this flow.

      Since:
        2.2

    - #### getMethodCalls

          public abstract List<MethodCallNode> getMethodCalls()

      Return an immutable data structure containing all the method call nodes declared for this flow.

      Since:
        2.2

    - #### getNode

          public abstract FlowNode getNode(String nodeId)

    - #### getNavigationCases

          public abstract Map<String,Set<NavigationCase>> getNavigationCases()

    - #### getClientWindowFlowId

          public abstract String getClientWindowFlowId(ClientWindow curWindow)

      Obtain the current `ClientWindow` from the `ExternalContext`. Get the window's id and append "_" and the return from `getId()`. Return the result.

      Since:
        2.2

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.